Firmware
Get firmware desired
**Send this request:** open the Swagger UI of your region, [Europe (EU)](https://lorawan-ns-eu.tektelic.com/swagger-ui.html) or [North America (NA)](https://lorawan-ns-na.tektelic.com/swagger-ui.html), then **firmware-controller** > `GET /api/firmware/desired/{entityType}/{entityId}`.
Save firmware desired
**Send this request:** open the Swagger UI of your region, [Europe (EU)](https://lorawan-ns-eu.tektelic.com/swagger-ui.html) or [North America (NA)](https://lorawan-ns-na.tektelic.com/swagger-ui.html), then **firmware-controller** > `PUT /api/firmware/desired/{entityType}/{entityId}`.
Delete firmware desired
**Send this request:** open the Swagger UI of your region, [Europe (EU)](https://lorawan-ns-eu.tektelic.com/swagger-ui.html) or [North America (NA)](https://lorawan-ns-na.tektelic.com/swagger-ui.html), then **firmware-controller** > `DELETE /api/firmware/desired/{entityType}/{entityId}`.
Get firmware reported
**Send this request:** open the Swagger UI of your region, [Europe (EU)](https://lorawan-ns-eu.tektelic.com/swagger-ui.html) or [North America (NA)](https://lorawan-ns-na.tektelic.com/swagger-ui.html), then **firmware-controller** > `GET /api/firmware/reported/{entityType}/{entityId}`.